<template>
  <div>
    <div class="header">
      <div class="header_left">
        <span @click="$router.push({name: 'Home'})">{{ title }}</span>
      </div>
      <div class="header_right">
        <div class="header_right_no_auth">
          <button v-if="$route.meta.isBack" class="login-back" @click="$router.go(-1)">Back</button>
          <button v-if="isBtnLogin && user.isLogin === false" class="login-btn" @click="$router.push({name: 'Login'})">Login</button>
          <button :disabled="isLoading" v-if="isBtnLogin && user.isLogin === true" class="login-btn" @click="logout">Logout ({{ user.obj.firstname }})</button>
          <button v-if="!isBtnLogin" class="login-btn" @click="btnData.fn">{{ btnData.title }}</button>
        </div>
      </div>
    </div>
    <div class="app-content">
      <router-view @changeTitle="changeTitleString" @setBtn="replaceLoginBtn"/>
    </div>
  </div>
</template>

<script>
import { getUserLoginObj, actionLogout } from './api'
export default {
  name: 'app',
  data() {
    return {
      title: "",
      isBtnLogin: true,
      btnData: {},
      isLoading: false,
      user: {
        isLogin: false,
        obj: {}
      }
    }
  },
  methods: {
    replaceLoginBtn(data) {
      if(data.title) {
        this.isBtnLogin = false;
        this.btnData = data;
      } else {
        this.isBtnLogin = true;
      }
    },
    changeTitleString(data) {
      this.title = data;
    },
    logout() {
      this.isLoading = true;
      actionLogout().then(() => {
        this.isLoading = false;
        this.$router.push({name: "Login"});
      });
    }
  },
  beforeUpdate() {
    // Check login action
    this.user = getUserLoginObj();
    if(this.$route.meta.isLogin === true) {
      if(this.$route.meta.loginStatus !== this.user.isLogin) {
        if(this.$route.meta.loginStatus === true) {
          this.$router.push({name: "Login"});
        } else {
          this.$router.push({name: "Home"});
        }
      }
    }
  }
}
</script>

<style>
body {
  padding: 0;
  margin: 0;
  font-size: 18px;
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}
.header {
  display: flex;
  justify-content: space-between;
  background: rgb(0, 183, 255);
  padding: 20px 20px;
}
.header_left {
  font-size: 20px;
  color: white;
  font-weight: bold;
}
.header_left span {
  cursor: pointer;
}
.login-back {
  border: none;
  padding: 5px 10px;
  border-radius: 5px;
  background: rgb(212, 212, 212);
  margin-right: 3px;
  cursor: pointer;
}
.login-btn {
  border: none;
  padding: 5px 10px;
  border-radius: 5px;
  background: #fff;
}
.login-btn:hover{
  background: rgb(216, 216, 216);
  cursor: pointer;
}
.app-content {
  padding: 20px 20px;
}
</style>
